'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.JavaArrayList = exports.JavaObject = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by rokoroku on 2016-08-23.
 */

var fs = require('fs');
var path = require('path');
var Java = require('java');

// Init java classes
var baseDir = path.join(__dirname, '../', 'jar');
var dependencies = fs.readdirSync(baseDir);
dependencies.forEach(function (dependency) {
    Java.classpath.push(baseDir + "/" + dependency);
});

var JavaObject = exports.JavaObject = function () {
    function JavaObject(className, value) {
        (0, _classCallCheck3.default)(this, JavaObject);

        if (value) {
            this._instance = Java.newInstanceSync(className, value);
        } else {
            this._instance = Java.newInstanceSync(className);
        }
    }

    (0, _createClass3.default)(JavaObject, [{
        key: 'instance',
        get: function get() {
            return this._instance;
        }
    }]);
    return JavaObject;
}();

var JavaArrayList = exports.JavaArrayList = function (_JavaObject) {
    (0, _inherits3.default)(JavaArrayList, _JavaObject);

    function JavaArrayList(value) {
        (0, _classCallCheck3.default)(this, JavaArrayList);
        return (0, _possibleConstructorReturn3.default)(this, Object.getPrototypeOf(JavaArrayList).call(this, 'java.util.ArrayList', value));
    }

    (0, _createClass3.default)(JavaArrayList, [{
        key: 'add',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
                var _this2 = this;

                for (var _len = arguments.length, items = Array(_len), _key = 0; _key < _len; _key++) {
                    items[_key] = arguments[_key];
                }

                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return items.map(function (item) {
                                    return _this2.instance.addSync(item);
                                });

                            case 2:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function add(_x) {
                return _ref.apply(this, arguments);
            }

            return add;
        }()
    }]);
    return JavaArrayList;
}(JavaObject);

var TwitterKoreanProcessor = function () {
    function TwitterKoreanProcessor() {
        (0, _classCallCheck3.default)(this, TwitterKoreanProcessor);
    }

    (0, _createClass3.default)(TwitterKoreanProcessor, null, [{
        key: 'normalize',


        /**
         * Normalize Korean text
         * 그랰ㅋㅋㅋㅋㅋㅋ -> 그래ㅋㅋ
         *
         * @param text Input text.
         * @return Normalized text.
         */
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(text) {
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                return _context2.abrupt('return', this.instance.normalizeSync(text));

                            case 1:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function normalize(_x2) {
                return _ref2.apply(this, arguments);
            }

            return normalize;
        }()

        /**
         * Tokenize with the builder options.
         *
         * @param text Input text.
         * @return A list of Korean Tokens (run tokensToJsonArray to transform to Java List)
         */

    }, {
        key: 'tokenize',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(text) {
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                return _context3.abrupt('return', this.instance.tokenizeSync(text));

                            case 1:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function tokenize(_x3) {
                return _ref3.apply(this, arguments);
            }

            return tokenize;
        }()

        /**
         * Add user-defined words to the noun dictionary. Spaced words are ignored.
         *
         * @param words List of user nouns.
         */

    }, {
        key: 'addNounsToDictionary',
        value: function () {
            var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
                for (var _len2 = arguments.length, words = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                    words[_key2] = arguments[_key2];
                }

                var list;
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                if (Array.isArray(words[0])) words = words[0];

                                list = new JavaArrayList();
                                _context4.next = 4;
                                return list.add.apply(list, (0, _toConsumableArray3.default)(words));

                            case 4:
                                return _context4.abrupt('return', this.instance.addNounsToDictionarySync(list.instance));

                            case 5:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function addNounsToDictionary(_x4) {
                return _ref4.apply(this, arguments);
            }

            return addNounsToDictionary;
        }()

        /**
         * Tokenize with the builder options into a Javascript Object.
         *
         * @param tokens Korean tokens (output of tokenize(CharSequence text)).
         * @param keepSpace Keep spaces
         * @return Array of token objects.
         */

    }, {
        key: 'tokensToJsonArray',
        value: function () {
            var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(tokens) {
                var keepSpace = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];
                var it, res, token, text, koreanPos, offset, length, isUnknown;
                return _regenerator2.default.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                it = tokens.iteratorSync();
                                res = [];

                                while (it.hasNextSync()) {
                                    token = it.nextSync();
                                    text = token.textSync();
                                    koreanPos = token.posSync().toString();
                                    offset = token.offsetSync();
                                    length = token.lengthSync();
                                    isUnknown = token.unknownSync();

                                    if (keepSpace || koreanPos !== 'Space') {
                                        res.push({ text: text, koreanPos: koreanPos, offset: offset, length: length, isUnknown: isUnknown });
                                    }
                                }
                                return _context5.abrupt('return', res);

                            case 4:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function tokensToJsonArray(_x5, _x6) {
                return _ref5.apply(this, arguments);
            }

            return tokensToJsonArray;
        }()

        /**
         * Stem Korean Verbs and Adjectives
         *
         * @param tokens Korean tokens (output of tokenize(CharSequence text)).
         * @return StemmedTextWithTokens(text, tokens)
         */

    }, {
        key: 'stem',
        value: function () {
            var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(tokens) {
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                return _context6.abrupt('return', this.instance.stemSync(tokens));

                            case 1:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function stem(_x8) {
                return _ref6.apply(this, arguments);
            }

            return stem;
        }()

        /**
         * Split input text into sentences.
         *
         * @param text Input text.
         * @return Array of Sentence objects.
         */

    }, {
        key: 'splitSentences',
        value: function () {
            var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(text) {
                var sentences, it, res, sentence, _text, start, end;

                return _regenerator2.default.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                sentences = this.instance.splitSentencesSync(text);
                                it = sentences.iteratorSync();
                                res = [];

                                while (it.hasNextSync()) {
                                    sentence = it.nextSync();
                                    _text = sentence.textSync();
                                    start = sentence.startSync();
                                    end = sentence.endSync();

                                    res.push({ text: _text, start: start, end: end });
                                }
                                return _context7.abrupt('return', res);

                            case 5:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function splitSentences(_x9) {
                return _ref7.apply(this, arguments);
            }

            return splitSentences;
        }()

        /**
         * Extract phrases from Korean input text
         *
         * @param tokens Korean tokens (output of tokenize(CharSequence text)).
         * @param filterSpam
         * @param includeHashtags
         * @return Array of phrase CharSequences.
         */

    }, {
        key: 'extractPhrases',
        value: function () {
            var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee8(tokens) {
                var filterSpam = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];
                var includeHashtags = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];
                var phrases, it, res, phrase, text, koreanPos, offset, length;
                return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                phrases = this.instance.extractPhrasesSync(tokens, filterSpam, includeHashtags);
                                it = phrases.iteratorSync();
                                res = [];

                                while (it.hasNextSync()) {
                                    phrase = it.nextSync();
                                    text = phrase.textSync();
                                    koreanPos = phrase.posSync().toString();
                                    offset = phrase.offsetSync();
                                    length = phrase.lengthSync();

                                    res.push({ text: text, koreanPos: koreanPos, offset: offset, length: length });
                                }
                                return _context8.abrupt('return', res);

                            case 5:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function extractPhrases(_x10, _x11, _x12) {
                return _ref8.apply(this, arguments);
            }

            return extractPhrases;
        }()

        /**
         * Detokenize the input list of words.
         *
         * @param words List of words.
         * @return String Detokenized string.
         */

    }, {
        key: 'detokenize',
        value: function () {
            var _ref9 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee9() {
                for (var _len3 = arguments.length, words = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                    words[_key3] = arguments[_key3];
                }

                var list, detokenized;
                return _regenerator2.default.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                if (Array.isArray(words[0])) words = words[0];

                                list = new JavaArrayList();
                                _context9.next = 4;
                                return list.add.apply(list, (0, _toConsumableArray3.default)(words));

                            case 4:
                                _context9.next = 6;
                                return this.instance.detokenizeSync(list.instance);

                            case 6:
                                detokenized = _context9.sent;
                                return _context9.abrupt('return', detokenized.toString());

                            case 8:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function detokenize(_x15) {
                return _ref9.apply(this, arguments);
            }

            return detokenize;
        }()
    }, {
        key: 'instance',
        get: function get() {
            if (!this._instance) {
                this._instance = Java.import('com.twitter.penguin.korean.TwitterKoreanProcessorJava');
            }
            return this._instance;
        }
    }]);
    return TwitterKoreanProcessor;
}();

exports.default = TwitterKoreanProcessor;